diff --git a/src/common/resources/lang/en_US/options.lang b/src/common/resources/lang/en_US/options.lang
index 416cee6b3..32adcf2ad 100644
--- a/src/common/resources/lang/en_US/options.lang
+++ b/src/common/resources/lang/en_US/options.lang
@@ -220,3 +220,4 @@ key.toggleDebug=Toggle Debug
 key.toggleOverlay=Toggle Overlays
 key.sortInventory=Sort Inventory
 key.disabled=Disabled
+key.debug.textureAtlas=Show Texture Atlas
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 899b5b561..612652f03 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -1,6 +1,20 @@
 package net.minecraft.client;
 
+import static net.minecraft.core.Global.*;
+import static org.lwjgl.opengl.GL11.*;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Random;
+
+import org.lwjgl.LWJGLException;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.Display;
+
 import com.mojang.nbt.CompoundTag;
+
 import net.minecraft.client.achievement.stat.StatStringFormatKeyInv;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.entity.ClientSkinVariantList;
@@ -30,6 +44,7 @@ import net.minecraft.client.gui.GuiSleepSP;
 import net.minecraft.client.gui.MainMenuBackground;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.input.InputHandler;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.MouseInput;
@@ -41,7 +56,6 @@ import net.minecraft.client.net.thread.ThreadCheckHasPaid;
 import net.minecraft.client.net.thread.ThreadDownloadResources;
 import net.minecraft.client.net.thread.ThreadSleepForeverClient;
 import net.minecraft.client.option.GameSettings;
-import net.minecraft.client.option.InputDevice;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerController;
@@ -130,35 +144,6 @@ import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveConverters;
 import net.minecraft.core.world.save.SaveFormats;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
-import org.lwjgl.LWJGLException;
-import org.lwjgl.input.Keyboard;
-import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.Display;
-
-import java.io.File;
-import java.io.IOException;
-import java.util.ArrayList;
-import java.util.Random;
-
-import static net.minecraft.core.Global.CURRENT_SAVE_VERSION;
-import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
-import static org.lwjgl.opengl.GL11.glAlphaFunc;
-import static org.lwjgl.opengl.GL11.glBindTexture;
-import static org.lwjgl.opengl.GL11.glClear;
-import static org.lwjgl.opengl.GL11.glClearColor;
-import static org.lwjgl.opengl.GL11.glClearDepth;
-import static org.lwjgl.opengl.GL11.glColor4f;
-import static org.lwjgl.opengl.GL11.glCullFace;
-import static org.lwjgl.opengl.GL11.glDepthFunc;
-import static org.lwjgl.opengl.GL11.glDisable;
-import static org.lwjgl.opengl.GL11.glEnable;
-import static org.lwjgl.opengl.GL11.glLoadIdentity;
-import static org.lwjgl.opengl.GL11.glMatrixMode;
-import static org.lwjgl.opengl.GL11.glOrtho;
-import static org.lwjgl.opengl.GL11.glShadeModel;
-import static org.lwjgl.opengl.GL11.glTranslatef;
-import static org.lwjgl.opengl.GL11.glViewport;
 
 // Referenced classes of package net.minecraft.client:
 //            MinecraftApplet
@@ -1114,7 +1099,9 @@ public class Minecraft
             }
             if(clickType == 1)
             {
-                playerController.interact(thePlayer, objectMouseOver.entity);
+                if (playerController.interact(thePlayer, objectMouseOver.entity)){
+                    flag = false;
+                }
             }
         }
         else if(objectMouseOver.hitType == HitResult.HitType.TILE)
@@ -1207,8 +1194,10 @@ public class Minecraft
         {
             startCheckPaidThread();
         }
+        Debug.push("gui");
         statsCounter.func_27178_d();
         ingameGUI.updateTick();
+        Debug.change("misc");
         worldRenderer.getMouseOver(1.0F);
         if(thePlayer != null)
         {
@@ -1225,11 +1214,13 @@ public class Minecraft
         {
             playerController.tick();
         }
+        Debug.change("textureTick");
         TextureRegistry.blockAtlas.bindTexture();
         if(!isGamePaused)
         {
             renderEngine.updateDynamicTextures();
         }
+        Debug.change("misc");
         if(currentScreen == null && thePlayer != null)
         {
             if(thePlayer.getHealth() <= 0)
@@ -1253,6 +1244,7 @@ public class Minecraft
         {
             displayGuiScreen(null);
         }
+        Debug.change("input");
         if(currentScreen != null)
         {
             mouseTicksRan = ticksRan + 10000;
@@ -1309,7 +1301,7 @@ public class Minecraft
                     }
                     else
                     {
-                        if (checkBoundInputs(InputDevice.MOUSE)) {
+                        if (checkBoundInputs(InputDevice.mouse)) {
                             if (!Mouse.isGrabbed() && inputType == InputType.KEYBOARD && currentScreen == null) {
                                 mouseInput.grabCursor();
                             }
@@ -1338,10 +1330,10 @@ public class Minecraft
                 	thePlayer.input.keyEvent(Keyboard.getEventKey(), Keyboard.getEventKeyState());
                 }
                 
-                if(gameSettings.keyToggleDebug.isPressEvent(InputDevice.KEYBOARD)) {
+                if(gameSettings.keyToggleDebug.isPressEvent(InputDevice.keyboard)) {
                     f3Press = true;
                 }
-                if (gameSettings.keyToggleDebug.isReleaseEvent(InputDevice.KEYBOARD))
+                if (gameSettings.keyToggleDebug.isReleaseEvent(InputDevice.keyboard))
                 {
                     if(f3Press)
                     {
@@ -1479,7 +1471,7 @@ public class Minecraft
                                 gameSettings.ambientOcclusion.onUpdate();
                                 ingameGUI.guiHeldItemTooltip.setOptionNameAndValueString(gameSettings.ambientOcclusion);
                             }
-                            if(!gameSettings.keyToggleDebug.isPressEvent(InputDevice.KEYBOARD)) f3Press = false;
+                            if(!gameSettings.keyToggleDebug.isPressEvent(InputDevice.keyboard)) f3Press = false;
                         }
                         else if (Keyboard.getEventKey() == Keyboard.KEY_F12)
                         {
@@ -1498,11 +1490,11 @@ public class Minecraft
                         }
                         else
                         {
-                            checkBoundInputs(InputDevice.KEYBOARD);
+                            checkBoundInputs(InputDevice.keyboard);
                         }
                     }
                 }else {
-                	checkBoundInputs(InputDevice.KEYBOARD);
+                	checkBoundInputs(InputDevice.keyboard);
                 }
             }
 
@@ -1520,6 +1512,7 @@ public class Minecraft
         {
             handleControllerInput();
         }
+        Debug.change("misc");
         if(theWorld != null)
         {
             if(thePlayer != null)
@@ -1549,27 +1542,36 @@ public class Minecraft
             }
             if(!isGamePaused)
             {
+                Debug.change("entity");
                 if(theWorld.lightningFlicker > 0)
                 {
                     theWorld.lightningFlicker--;
                 }
                 theWorld.updateEntities();
+                Debug.change("misc");
             }
             if(!isGamePaused || isMultiplayerWorld())
             {
+                Debug.change("world");
                 theWorld.setAllowedMobSpawns(gameSettings.difficulty.value.canMobsSpawn(), true);
                 theWorld.tick();
+                Debug.change("misc");
             }
             if(!isGamePaused && theWorld != null)
             {
+                Debug.change("randomDisplayTick");
                 theWorld.randomDisplayUpdates(MathHelper.floor_double(thePlayer.x), MathHelper.floor_double(thePlayer.y), MathHelper.floor_double(thePlayer.z));
+                Debug.change("misc");
             }
             if(!isGamePaused)
             {
+                Debug.change("effects");
                 effectRenderer.updateEffects();
+                Debug.change("misc");
             }
         }
         systemTime = System.currentTimeMillis();
+        Debug.pop();
     }
 
     private boolean checkBoundInputs(InputDevice currentInputDevice) {
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java
index d6fb40119..076052cfb 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java
@@ -14,14 +14,14 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class EntityDiggingFX extends EntityFX
-{    public EntityDiggingFX(World world, double d, double d1, double d2,
-                           double d3, double d4, double d5, Block block,
-                           int i, int meta)
+{    public EntityDiggingFX(World world, double x, double y, double z,
+                           double motionX, double motionY, double motionZ, Block block,
+                           int side, int meta)
     {
-        super(world, d, d1, d2, d3, d4, d5);
-        this.side = Side.getSideById(i);
+        super(world, x, y, z, motionX, motionY, motionZ);
+        this.side = Side.getSideById(side);
         this.block = block;
-        particleTexture = BlockModelDispatcher.getInstance().getDispatch(block).getParticleTexture(side, meta);
+        particleTexture = BlockModelDispatcher.getInstance().getDispatch(block).getParticleTexture(this.side, meta);
         this.particleGravity = block != null ? block.blockParticleGravity : 0;
         this.particleRed = particleGreen = particleBlue = 0.6F;
         this.particleScale /= 2.0F;
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityReddustFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityReddustFX.java
index b8b7026a5..f020e8094 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityReddustFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityReddustFX.java
@@ -1,21 +1,30 @@
 package net.minecraft.client.entity.fx;
 
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
 public class EntityReddustFX extends EntityFX
 {
+    float originalScale;
+    private int brightness;
 
-    public EntityReddustFX(World world, double x, double y, double z, float red, float green, float blue)
+    public EntityReddustFX(World world, double x, double y, double z, float red, float green, float blue, int brightness)
     {
-        this(world, x, y, z, 1.0F, red, green, blue);
+        this(world, x, y, z, 1.0F, red, green, blue, brightness);
     }
 
-    public EntityReddustFX(World world, double x, double y, double z, float scale, float red, float green, float blue)
+    public EntityReddustFX(World world, double x, double y, double z, float scale, float red, float green, float blue, int brightness)
     {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.brightness = -1;
+        if (brightness >= 0){
+            this.brightness = brightness;
+        }
         xd *= 0.1D;
         yd *= 0.1D;
         zd *= 0.1D;
@@ -25,7 +34,7 @@ public class EntityReddustFX extends EntityFX
         this.particleBlue = ((float)(Math.random() * 0.2D) + 0.8F) * blue * f4;
         particleScale *= 0.75F;
         particleScale *= scale;
-        field_673_a = particleScale;
+        this.originalScale = particleScale;
         particleMaxAge = (int)(8D / (Math.random() * 0.8D + 0.2D));
         particleMaxAge *= scale;
         noPhysics = false;
@@ -43,8 +52,40 @@ public class EntityReddustFX extends EntityFX
         {
             f6 = 1.0F;
         }
-        particleScale = field_673_a * f6;
-        super.renderParticle(t, partialTick, rotationX, rotationXZ, rotationZ, rotationYZ, rotationXY);
+        particleScale = originalScale * f6;
+        if (particleTexture == null) return;
+
+        float texMinU = (float) particleTexture.getIconUMin();
+        float texMaxU = (float) particleTexture.getSubIconU(1);
+        float texMinV = (float) particleTexture.getIconVMin();
+        float texMaxV = (float) particleTexture.getSubIconV(1);
+        float scale = 0.1F * particleScale;
+        float posX = (float)((xo + (this.x - xo) * (double)partialTick) - lerpPosX);
+        float posY = (float)((yo + (this.y - yo) * (double)partialTick) - lerpPosY);
+        float posZ = (float)((zo + (this.z - zo) * (double)partialTick) - lerpPosZ);
+        float brightness = 1f;
+        if(LightmapHelper.isLightmapEnabled()) {
+            int blockX = MathHelper.floor_double(x);
+            int blockY = MathHelper.floor_double(y);
+            int blockZ = MathHelper.floor_double(z);
+            int lmc;
+            if (this.brightness >= 0){
+                lmc =
+                    LightmapHelper.getLightmapCoord(
+                        world.getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ),
+                        Math.max(world.getSavedLightValue(LightLayer.Block, blockX, blockY, blockZ), this.brightness));
+            } else {
+                lmc = getLightmapCoord(partialTick);
+            }
+            t.setLightmapCoord(lmc);
+        }else {
+            brightness = Math.max(getBrightness(partialTick), this.brightness/15f);
+        }
+        t.setColorOpaque_F(particleRed * brightness, particleGreen * brightness, particleBlue * brightness);
+        t.addVertexWithUV(posX - rotationX * scale - rotationYZ * scale, posY - rotationXZ * scale, posZ - rotationZ * scale - rotationXY * scale, texMaxU, texMaxV);
+        t.addVertexWithUV((posX - rotationX * scale) + rotationYZ * scale, posY + rotationXZ * scale, (posZ - rotationZ * scale) + rotationXY * scale, texMaxU, texMinV);
+        t.addVertexWithUV(posX + rotationX * scale + rotationYZ * scale, posY + rotationXZ * scale, posZ + rotationZ * scale + rotationXY * scale, texMinU, texMinV);
+        t.addVertexWithUV((posX + rotationX * scale) - rotationYZ * scale, posY - rotationXZ * scale, (posZ + rotationZ * scale) - rotationXY * scale, texMinU, texMaxV);
     }
 
     @Override
@@ -78,6 +119,4 @@ public class EntityReddustFX extends EntityFX
             zd *= 0.7D;
         }
     }
-
-    float field_673_a;
 }
diff --git a/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java b/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
index 4eae7cab1..847ef2194 100644
--- a/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
+++ b/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
@@ -39,7 +39,7 @@ public class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
         addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFootStepFX(mc.renderEngine, world, x, y, z));
         addDispatch("splash", (world1, d, d1, d2, d3, d4, d5, data) -> new EntitySplashFX(world1, d, d1, d2, d3, d4, d5));
         addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySmokeFX(world, x, y, z, motionX, motionY, motionX, 2.5f));
-        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityReddustFX(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ));
+        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityReddustFX(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
         addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityItemFX(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
         addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityDiggingFX(world, x, y, z,motionX,motionY,motionZ, Block.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).setParticleColor((int) x, (int) y, (int) z));
         addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySnowShovelFX(world, x, y, z, motionX, motionY, motionX));
diff --git a/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java b/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java
index 6eb59bb5e..554049899 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java
+++ b/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java
@@ -80,7 +80,7 @@ public class EntityOtherPlayerMP extends EntityPlayer
     }
     
     @Override
-	public void onDeath(Entity entity)
+	public void onDeath(Entity entityKilledBy)
     {
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiHeldItemTooltip.java b/src/main/java/net/minecraft/client/gui/GuiHeldItemTooltip.java
index 5d7a1e82a..4d4b2fbc7 100644
--- a/src/main/java/net/minecraft/client/gui/GuiHeldItemTooltip.java
+++ b/src/main/java/net/minecraft/client/gui/GuiHeldItemTooltip.java
@@ -28,7 +28,7 @@ public class GuiHeldItemTooltip extends Gui {
 		this.mc = mc;
 	}
 	
-	public void updateAndRender(Minecraft mc, int width, int height, int sp) {
+	public void updateAndRender(Minecraft mc, int width, int height, int screenPadding) {
 		if(mc.gameSettings.heldItemTooltips.value) {
 			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 			
@@ -45,7 +45,26 @@ public class GuiHeldItemTooltip extends Gui {
 			}
 		}
 		
-		render(mc, width, height, sp);
+		render(mc, width, height, screenPadding);
+	}
+	public void updateAndRender(Minecraft mc, int x, int y) {
+		if(mc.gameSettings.heldItemTooltips.value) {
+			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
+
+			int id = getItemID(item);
+			int i = mc.thePlayer.inventory.currentItem;
+
+			if(id != lastItemID || i != lastSelectedItem) {
+				updateString(item);
+
+				time = displayTime;
+
+				lastItemID = id;
+				lastSelectedItem = i;
+			}
+		}
+
+		render(mc, x, y);
 	}
 	
 	private void updateString(ItemStack item) {
@@ -73,14 +92,17 @@ public class GuiHeldItemTooltip extends Gui {
 		this.time = displayTime;
 	}
 	
-	public void render(Minecraft mc, int width, int height, int sp) {
+	public void render(Minecraft mc, int width, int height, int screenPadding) {
+		render(mc, width/2, height - 50 - screenPadding);
+	}
+	public void render(Minecraft mc, int x, int y){
 		if(string == null) return;
 		if(time < 0.0) {
 			return;
 		}
-		
+
 		double alpha;
-		
+
 		if (time < fadeTime) {
 			alpha = time / fadeTime;
 		} else {
@@ -90,21 +112,21 @@ public class GuiHeldItemTooltip extends Gui {
 		if(!mc.isGamePaused) {
 			time -= Time.delta;
 		}
-		
+
 		int a = (int) (alpha * 255);
 		if(a < 1) {
 			return;
 		}
-		
+
 		int rgb = (color & 0x00FFFFFF) | (a << 24);
-		
+
 		if(a < 255) {
 			glEnable(GL_BLEND);
 			glDisable(GL_ALPHA_TEST);
-	        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 		}
-		
-		mc.fontRenderer.drawStringWithShadow(string, (width - mc.fontRenderer.getStringWidth(string)) / 2, height - 50 - sp, rgb);
+
+		mc.fontRenderer.drawStringWithShadow(string, x - (mc.fontRenderer.getStringWidth(string)) / 2, y, rgb);
 
 		glDisable(GL_BLEND);
 		glEnable(GL_ALPHA_TEST);
diff --git a/src/main/java/net/minecraft/client/gui/GuiIngame.java b/src/main/java/net/minecraft/client/gui/GuiIngame.java
index ab4d71d30..0d77bae83 100644
--- a/src/main/java/net/minecraft/client/gui/GuiIngame.java
+++ b/src/main/java/net/minecraft/client/gui/GuiIngame.java
@@ -9,7 +9,6 @@ import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
-import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -527,18 +526,13 @@ public class GuiIngame extends Gui
 
         }
 
-        if (mc.gameSettings.immersiveMode.drawHotbar())
-        {
-            guiHeldItemTooltip.updateAndRender(mc, width, height, sp);
-        }
-        
         if (mc.gameSettings.immersiveMode.drawChat())
         {
         	drawChat(width, height, sp);
         }
-
+        
         // Adding this mostly to see if the stitcher and dynamic textures are working properly
-        if (Keyboard.isKeyDown(Keyboard.KEY_F6) && mc.theWorld.getLevelData().getCheatsEnabled()){
+        if (mc.gameSettings.keyToggleTextureAtlas.isPressed()) {
             Tessellator tessellator = Tessellator.instance;
 
             TextureRegistry.blockAtlas.bindTexture();
diff --git a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
index 80e3509f4..96d56e2af 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui.hud;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.GuiHeldItemTooltip;
 import net.minecraft.client.gui.GuiIngame;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.Scissor;
@@ -123,6 +124,8 @@ public class HotbarComponent
 
         // Render selector
         gui.drawTexturedModalRect((x + 4) + (inv.currentItem % 9) * 20, y - 1, 0, 22, 24, 24);
+
+        gui.guiHeldItemTooltip.updateAndRender(mc, x + 187/2, y - 20);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
index 896e066a2..e6f3b2790 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
@@ -71,7 +71,7 @@ public class RedDustFXEntry extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new EntityReddustFX(world, x, y, z, red/255f, green/255f, blue/255f));
+        mc.effectRenderer.addEffect(new EntityReddustFX(world, x, y, z, red/255f, green/255f, blue/255f, 15));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java b/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
index 787a0ef13..fb530fc7c 100644
--- a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
+++ b/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
@@ -7,6 +7,7 @@ import net.minecraft.client.gui.options.components.KeyBindingComponent;
 import net.minecraft.client.gui.options.components.OptionsComponent;
 import net.minecraft.client.gui.options.data.OptionsPage;
 import net.minecraft.client.gui.options.data.OptionsPages;
+import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.gui.options.data.OptionsPageRegistry;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.render.Scissor;
@@ -84,7 +85,7 @@ public class GuiOptions
                 pickingKeyBindingComponent = null;
                 return;
             }
-            pickingKeyBinding.bindKeyboard(key);
+            pickingKeyBinding.bind(InputDevice.keyboard, key);
             pickingKeyBindingComponent.update();
             pickingKeyBinding = null;
             pickingKeyBindingComponent = null;
@@ -393,7 +394,7 @@ public class GuiOptions
     public void mouseClicked(int mouseX, int mouseY, int mouseButton)
     {
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
-            pickingKeyBinding.bindMouse(mouseButton);
+            pickingKeyBinding.bind(InputDevice.mouse, mouseButton);
             pickingKeyBindingComponent.update();
             pickingKeyBinding = null;
             pickingKeyBindingComponent = null;
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 60ed1402d..bcab897a5 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -216,6 +216,7 @@ public abstract class OptionsPages
         .withComponent(new SearchFieldComponent())
     );
     public static final OptionsPage DEBUG = new OptionsPage("gui.options.page.debug.title", Block.bedrock.getDefaultStack())
+    		.withComponent(new KeyBindingComponent(mc.gameSettings.keyToggleTextureAtlas))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
                 mc.playerController = new PlayerControllerSP(mc);
                 mc.changeWorld(new World(), "Loading Model Viewer");
diff --git a/src/main/java/net/minecraft/client/input/InputDevice.java b/src/main/java/net/minecraft/client/input/InputDevice.java
new file mode 100644
index 000000000..9a1324a08
--- /dev/null
+++ b/src/main/java/net/minecraft/client/input/InputDevice.java
@@ -0,0 +1,18 @@
+package net.minecraft.client.input;
+
+public abstract class InputDevice {
+	
+	public static InputDevice mouse = new InputDeviceMouse();
+	public static InputDevice keyboard = new InputDeviceKeyboard();
+	
+	public abstract boolean isPressed(int keyCode);
+	
+	public abstract boolean isPressEvent(int keyCode);
+	
+	public abstract boolean isReleaseEvent(int keyCode);
+	
+	public abstract boolean isKeyCodeValid(int keyCode);
+	
+	public abstract String getKeyName(int keyCode);
+	
+}
diff --git a/src/main/java/net/minecraft/client/input/InputDeviceKeyboard.java b/src/main/java/net/minecraft/client/input/InputDeviceKeyboard.java
new file mode 100644
index 000000000..7b64cee80
--- /dev/null
+++ b/src/main/java/net/minecraft/client/input/InputDeviceKeyboard.java
@@ -0,0 +1,32 @@
+package net.minecraft.client.input;
+
+import org.lwjgl.input.Keyboard;
+
+public class InputDeviceKeyboard extends InputDevice {
+
+	@Override
+	public boolean isPressed(int keyCode) {
+		return Keyboard.isKeyDown(keyCode);
+	}
+
+	@Override
+	public boolean isPressEvent(int keyCode) {
+		return Keyboard.getEventKey() == keyCode && Keyboard.getEventKeyState();
+	}
+
+	@Override
+	public boolean isReleaseEvent(int keyCode) {
+		return Keyboard.getEventKey() == keyCode && !Keyboard.getEventKeyState();
+	}
+
+	@Override
+	public boolean isKeyCodeValid(int keyCode) {
+		return keyCode > 0;
+	}
+
+	@Override
+	public String getKeyName(int keyCode) {
+		return Keyboard.getKeyName(keyCode);
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/input/InputDeviceMouse.java b/src/main/java/net/minecraft/client/input/InputDeviceMouse.java
new file mode 100644
index 000000000..8a4864c19
--- /dev/null
+++ b/src/main/java/net/minecraft/client/input/InputDeviceMouse.java
@@ -0,0 +1,38 @@
+package net.minecraft.client.input;
+
+import org.lwjgl.input.Mouse;
+
+public class InputDeviceMouse extends InputDevice {
+	
+	private static final String[] MOUSE_BUTTON_NAMES = new String[] { "LEFT CLICK", "RIGHT CLICK", "MIDDLE CLICK" };
+
+	@Override
+	public boolean isPressed(int keyCode) {
+		return Mouse.isButtonDown(keyCode);
+	}
+
+	@Override
+	public boolean isPressEvent(int keyCode) {
+		return Mouse.getEventButton() == keyCode && Mouse.getEventButtonState();
+	}
+
+	@Override
+	public boolean isReleaseEvent(int keyCode) {
+		return Mouse.getEventButton() == keyCode && !Mouse.getEventButtonState();
+	}
+
+	@Override
+	public boolean isKeyCodeValid(int keyCode) {
+		return keyCode >= 0;
+	}
+
+	@Override
+	public String getKeyName(int keyCode) {
+		if (keyCode < MOUSE_BUTTON_NAMES.length) {
+			return MOUSE_BUTTON_NAMES[keyCode];
+		} else {
+			return "MOUSE " + (keyCode + 1);
+		}
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java b/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
index 563d0dd58..830b2423c 100644
--- a/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
@@ -627,7 +627,7 @@ public class NetClientHandler extends NetHandler
     @Override
     public void handleBlockChange(Packet53BlockChange packet53blockchange)
     {
-        worldClient.func_714_c(packet53blockchange.xPosition, packet53blockchange.yPosition, packet53blockchange.zPosition, packet53blockchange.type, packet53blockchange.metadata);
+        worldClient.blockChange(packet53blockchange.xPosition, packet53blockchange.yPosition, packet53blockchange.zPosition, packet53blockchange.type, packet53blockchange.metadata);
     }
 
     @Override
